uses Crt, Graph;

const
  XMin     :real    = 0;
  XMax     :real    = 639;
  Ymin     :real    = 479;
  Ymax     :real    = 0;
  BGIpath  :string  ='C:\BP\BGI';
var
 grDriver : Integer;
 grMode   : Integer;
 ErrCode  : Integer;
 I,MAX1   : integer;
 X,Y      : real;
 Dil      : integer;
 T        : INTEGER;
 ViewPort : ViewPortType;
Function XR(XX:real):integer;
  var
    XP:integer;
    YP:integer;
  begin
    GetViewSettings(ViewPort);
    With ViewPort do
    Xp := Round((X2-X1)*((XX-XMin)/(XMax-XMin)));
    XR:=XP;
  end;{XR}
Function YR(YY:real):integer;
  begin
    GetViewSettings(ViewPort);
    With ViewPort do
    YR := Round(Y2-Y1-(Y2-Y1)*((YY-YMin)/(YMax-YMin)));
  end;{YR}

Procedure Frame;
  begin
    GetViewSettings(ViewPort);
    With ViewPort do
    Rectangle(XR(XMin),YR(YMin),XR(XMax),YR(YMax));

{    Rectangle(0,0,GetMaxX,GetMaxY);}{Nekresli vzadu a dole}
  end;{Frame}
procedure RASTER(Color:word);
  var
    CurrColor:word;
    XText,YText : String;
    I:integer;
  begin
    CurrColor:=GetColor;
    SetColor(Color);
    SetLineStyle(SolidLn,0,ThickWidth);
    Frame;
    SetLineStyle(SolidLn,0,NormWidth);
    Line(XR(XMin),YR(0),XR(XMax),YR(0));  {vodorovn osa}
    Line(XR(0),YR(YMin),XR(0),YR(YMax));  {svisl osa}
    Dil:=2;
    for I:=0 to dil do
    begin
      STR(I*XMax/Dil:1:0,XText);
      STR(I*YMax/Dil:3:1,YText);
      MoveTo(XR(I*XMax/Dil),YR(0));
      MoveRel(0,-5);
      LineRel(0,10);
      OutText(XText);
      MoveTo(XR(-(I*XMax/Dil)),YR(0));
      MoveRel(0,-5);
      LineRel(0,10);
      If I>0 then OutText('-');
      OutText(XText);
      MoveTo(XR(0),YR(I*YMax/Dil));
      MoveRel(-5,0);
      LineRel(10,0);
      MoveRel(0,3);
      if I>0 then OutText(YText);
      MoveTo(XR(0),YR(-(I*YMax/Dil)));
      MoveRel(-5,0);
      LineRel(10,0);
      If I>0 then
      begin
        MoveRel(0,-8);
        OutText('-');
        OutText(YText);
      end;{If}
    end;{For I}
    SetColor(CurrColor);
  end;{Raster}
procedure DrawSinus;
  begin
    SetBkColor(Blue);
    RASTER(LightGreen);
    SetColor(Yellow);
  {  Sinusovka}
    MoveTo(XR(XMIN*0.95),YR(Ymax*0.9));
    OutText('y=Sin(x)');
    X:=XMIN;
    Y:=SIN(X);
    MoveTO(XR(X),YR(Y));
    While X<=Xmax do
    begin
      X:=X+2*pi/360;
      Y:=SIN(X);
      PutPixel(XR(X),YR(Y),LightRed);
  {    LineTo(XR(X),YR(Y+0.1));    }
    end;{While}
  end;
procedure DrawArchimedesSpirale;
{Ro:=A*Fi}
  const
    A=1.0;
  var
    Ro,Fi:real;
    XP,YP:integer;
  begin
    RASTER(LightGreen);
    SetColor(Yellow);
  {  Archimedes spirala}
    MoveTo(XR(XMIN*0.95),YR(Ymax*0.9));
    OutText('Archimedes spirala');
    SetColor(LightBlue);
    Fi:=0;
    Ro:=A*Fi;
    X:=Ro*Cos(Fi);
    Y:=Ro*sin(Fi);
    MoveTO(XR(X),YR(Y));
    While Fi < 9*360*Pi/180 do
    begin
      FI:=Fi+5*pi/180;
      Ro:=A*Fi;
      X:=Ro*Cos(Fi);
      XP:=XR(X);
      Y:=Ro*sin(Fi);
      YP:=YR(Y);
{      PutPixel(XR(X),YR(Y),LightGreen);}
      LineTo(XR(X),YR(Y));
    end;{While}
  end;
procedure DrawLogSpirale;
{Ro:=A*exp(B*Fi)}
  const
    A=0.1;
    B=0.1;
  var
    Ro,Fi:real;
  begin
    RASTER(LightGreen);
    SetColor(Yellow);
    Fi:=0;
    Ro:=A*exp(B*Fi);
    X:=Ro*Cos(Fi);
    Y:=Ro*sin(Fi);
    MoveTO(XR(X),YR(Y));
    While Fi < 6*360*Pi/180 do
    begin
      FI:=Fi+5*pi/180;
      Ro:=A*exp(B*Fi);
      X:=Ro*Cos(Fi);
      Y:=Ro*sin(Fi);
{      PutPixel(XR(X),YR(Y),LightGreen);}
      LineTo(XR(X),YR(Y));
    end;{While}
  end;

procedure DrawCardio;
{
 x:=A*cos(T*(T+cos(T));
 y:=A*sin(T*(1+cos(T));}
  const
    A=1;
  var
    Ro,Fi:real;
  begin
    RASTER(LightGreen);
    SetLineStyle(SolidLn,0,ThickWidth);
    SetColor(Yellow);
    Fi:=0;
    Ro:=A*(1+cos(FI));
    X:=Ro*cos(Fi);
    Y:=Ro*Sin(Fi);

    MoveTO(XR(X),YR(Y));
    While Fi < 360*Pi/180 do
    begin
      Fi:=Fi+5*pi/180;
      Ro:=A*(1+cos(FI));
      X:=Ro*cos(Fi);
      Y:=Ro*Sin(Fi);
      LineTo(XR(X),YR(Y));
    end;{While}
  end;
procedure DrawCruciform;
  const
    A=1;
  var
    Ro,Fi:real;
  begin
    RASTER(LightGreen);
    SetColor(Yellow);
    Fi:=0;
    if Sin(2*Fi)<>0 then Ro:=2*A/sin(2*Fi);
    X:=Ro*cos(Fi);
    Y:=Ro*Sin(Fi);
    MoveTO(XR(X),YR(Y));
    While Fi < 360*Pi/180 do
    begin
      Fi:=Fi+pi/360;
      if Sin(2*Fi)<>0 then Ro:=2*A/sin(2*Fi);
      X:=Ro*cos(Fi);
      Y:=Ro*Sin(Fi);
      If ABS(Ro)<maxint then   PutPixel(XR(X),YR(Y),LightGreen);
    end;{While}
  end;
procedure   DrawEpiCykloide;
  const
    A=2;
    B=8.0;
    L=1;
    XL:real=0;
    YL:real=0;
  var
    Fi,FiFi:real;
  begin
    RASTER(LightGreen);
    SetColor(Yellow);
    Fi:=0;
    X:=(A+B)*cos(Fi)-L*a*cos((A+B)*Fi/A);
    Y:=(A+B)*sin(Fi)-L*a*sin((A+B)*Fi/A);
    MoveTO(XR(X),YR(Y));
    While Fi < 360*Pi/180 do
    begin
      SetColor(Blue);
Ellipse(XR(XL),YR(YL),0,360,Round(A*(Viewport.X2-ViewPort.X1)/(XMax-XMin)),Round(A*(Viewport.Y2-ViewPort.Y1)/(YMax-YMin)));
      Fi:=Fi+pi/720;
      SetColor(White);
      Ellipse(XR(0),YR(0),0,360,Round(B*(Viewport.X2-ViewPort.X1)/(XMax-XMin)),Round(B*(Viewport.Y2-ViewPort.Y1)/(YMax-YMin)));
      XL:=(B+A)*cos(FI);
      YL:=(B+A)*sin(fi);
Ellipse(XR(XL),YR(YL),0,360,Round(A*(Viewport.X2-ViewPort.X1)/(XMax-XMin)),Round(A*(Viewport.Y2-ViewPort.Y1)/(YMax-YMin)));
      fiFi:=Fi-45*pi/360;
      IF Fi<0 then Fi:=0;
      While FiFi <= Fi do
      begin
        FiFi:=FiFi+pi/180;
        X:=(A+B)*cos(FiFi)-L*a*cos((A+B)*FiFi/A);
        Y:=(A+B)*sin(FiFi)-L*a*sin((A+B)*FiFi/A);
        PutPixel(XR(X),YR(Y),Yellow);
      end;
    end;{While}
{    Circle(XR(0),YR(0),Round(B*(Viewport.X2-ViewPort.X1)/(XMax-XMin)));
                                       }
  end;
procedure DrawCykloide;
  const
    A=1;
    B=8.0;
    L=1;
    XL:real=0;
    YL:real=0;
  var
    T:real;
  begin
    RASTER(LightGreen);
    SetColor(LightRed);
    MoveTo(XR(XMin),YR(YMin));
    T:=0;
    While T <= 8*Pi do
    begin
      T:=T+2*Pi/180;
      X:=A*(T-Sin(T));
      Y:=A*(1-Cos(T));
      PutPixel(XR(X),YR(Y),LightRed);
    end;{While}

{    Circle(XR(0),YR(0),Round(B*(Viewport.X2-ViewPort.X1)/(XMax-XMin)));
                                       }
  end;
Procedure DrawAsteroide;
{
 x:=A*cos(T*(T+cos(T));
 y:=A*sin(T*(1+cos(T));}
  const
    A=1;
  var
    Ro,Fi,T:real;
  begin
{    SetBkColor(Black);}
    RASTER(LightGreen);
    SetLineStyle(SolidLn,0,ThickWidth);
    SetColor(Yellow);
    T:=0;
    x:=A*cos(t)*Cos(t)*Cos(t);
    y:=A*sin(t)*sin(t)*sin(t);

    MoveTO(XR(X),YR(Y));
    While T < 360*Pi/180 do
    begin
      T:=T+5*pi/180;
      x:=A*cos(t)*Cos(t)*Cos(t);
      y:=A*sin(t)*sin(t)*sin(t);
      LineTo(XR(X),YR(Y));
    end;{While}
    MAX1:=GetmaxX;
  end;

begin  {  =========================   Main ==========================  }

  grDriver := Detect;
  InitGraph(grDriver, grMode,BGIpath );
  ErrCode := GraphResult;
  if ErrCode <> grOk then exit;
{  SetGraphMode(2);   }
  SetviewPort(0,0,213,169,True);
  XMin:= -2*pi;
  XMax:= 2*pi;
  YMax:= 2;
  YMin:= -2;
  DrawSinus;

  SetviewPort(213,0,426,169,True);
  XMin:=-16*pi;
  XMax:=16*pi;
  Ymin:=-12*pi;
  Ymax:=12*pi;
  DrawArchimedesSpirale;

  SetviewPort(426,0,639,169,True);
  XMin:=-4;
  XMax:=4;
  Ymin:=-3;
  Ymax:=3;
  DrawLogSpirale;

  SetviewPort(0,169,213,339,True);
  XMin:=-2;
  XMax:=2;
  Ymin:=-1.5;
  Ymax:=1.5;
  DrawCardio;

  SetViewPort(0,340,213,479,ClipOn);
  XMin:=0;
  XMax:=8*Pi;
  YMin:=-2;
  YMax:=2;
  DrawCykloide;

  SetViewPort(214,340,426,479,ClipOn);
  XMin:=-3;
  XMax:=3;
  Ymin:=-2;
  Ymax:=2;
  DrawAsteroide;
  SetviewPort(213,169,426,339,True);
  SetBkColor(Black);
  XMin:=-16;
  XMax:=16;
  Ymin:=-12;
  Ymax:=12;
  DrawCruciform;
  SetBkColor(Blue);
  SetviewPort(426,169,639,339,true);
  DrawEpiCykloide;
  Repeat until KeyPressed;
  CloseGraph;
writeln('MAX1',MAX1);
{  Writeln(ErrCode);}
end.
